



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android ANR分析(三)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android ANR分析(三)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 15:11:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>http://www.jianshu.com/p/8964812972be</p>
<p>http://stackoverflow.com/questions/704311/android-how-do-i-investigate-an-anr</p>
<div>
<h1>Keeping Your App Responsive</h1>
<div><a href="https://developer.android.com/training/multiple-threads/communicate-ui.html" rel="external nofollow noreferrer">Previous</a><a href="https://developer.android.com/training/articles/perf-jni.html" rel="external nofollow noreferrer">Next</a></div>
</div>
<div>
<div>
<div>
<h2>In this document</h2>
<ol><li><a href="https://developer.android.com/training/articles/perf-anr.html#anr" rel="external nofollow noreferrer">What Triggers ANR?</a></li>
<li><a href="https://developer.android.com/training/articles/perf-anr.html#Avoiding" rel="external nofollow noreferrer">How to Avoid ANRs</a></li>
<li><a href="https://developer.android.com/training/articles/perf-anr.html#Reinforcing" rel="external nofollow noreferrer">Reinforcing Responsiveness</a></li></ol>
<h2>You should also read</h2>
<ul><li><a href="https://developer.android.com/topic/performance/background-optimization.html" rel="external nofollow noreferrer">Background Optimizations</a></li>
<li><a href="https://developer.android.com/topic/performance/scheduling.html" rel="external nofollow noreferrer">Intelligent Job-Scheduling</a></li>
<li><a href="https://developer.android.com/training/monitoring-device-state/manifest-receivers.html" rel="external nofollow noreferrer">Manipulating Broadcast Receivers On Demand</a></li>
<li><a href="https://developer.android.com/guide/components/intents-filters.html" rel="external nofollow noreferrer">Intents and Intent Filters</a></li></ul>
</div>
</div>
<div><img referrerpolicy="no-referrer"src="https://developer.android.com/images/anr.png" /></p>
<p><strong>Figure 1.</strong>&nbsp;An ANR dialog displayed to the user.</p>
</div>
<p>It's possible to write code that wins every performance test in the world, but still feels sluggish, hang or freeze for significant periods, or take too long to process input. The worst thing that can happen to your app's responsiveness is an "Application Not Responding" (ANR) dialog.</p>
<p>In Android, the system guards against applications that are insufficiently responsive for a period of time by displaying a dialog that says your app has stopped responding, such as the dialog in Figure 1. At this point, your app has been unresponsive for a considerable period of time so the system offers the user an option to quit the app. It's critical to design responsiveness into your application so the system never displays an ANR dialog to the user.</p>
<p>This document describes how the Android system determines whether an application is not responding and provides guidelines for ensuring that your application stays responsive.</p>
<h2>What Triggers ANR?</h2>
<hr />
<p>Generally, the system displays an ANR if an application cannot respond to user input. For example, if an application blocks on some I/O operation (frequently a network access) on the UI thread so the system can't process incoming user input events. Or perhaps the app spends too much time building an elaborate in-memory structure or computing the next move in a game on the UI thread. It's always important to make sure these computations are efficient, but even the most efficient code still takes time to run.</p>
<p>In any situation in which your app performs a potentially lengthy operation,&nbsp;<strong>you should not perform the work on the UI thread</strong>, but instead create a worker thread and do most of the work there. This keeps the UI thread (which drives the user interface event loop) running and prevents the system from concluding that your code has frozen. Because such threading usually is accomplished at the class level, you can think of responsiveness as a&nbsp;<em>class</em>&nbsp;problem. (Compare this with basic code performance, which is a&nbsp;<em>method</em>-level concern.)</p>
<p>In Android, application responsiveness is monitored by the Activity Manager and Window Manager system services. Android will display the ANR dialog for a particular application when it detects one of the following conditions:</p>
<ul><li>No response to an input event (such as key press or screen touch events) within 5 seconds.</li>
<li>A&nbsp;<code><a href="https://developer.android.com/reference/android/content/BroadcastReceiver.html" rel="external nofollow noreferrer">BroadcastReceiver</a></code>&nbsp;hasn't finished executing within 10 seconds.</li></ul>
<h2>How to Avoid ANRs</h2>
<hr />
<p>Android applications normally run entirely on a single thread by default the "UI thread" or "main thread"). This means anything your application is doing in the UI thread that takes a long time to complete can trigger the ANR dialog because your application is not giving itself a chance to handle the input event or intent broadcasts.</p>
<p>Therefore, any method that runs in the UI thread should do as little work as possible on that thread. In particular, activities should do as little as possible to set up in key life-cycle methods such as&nbsp;<code><a href="https://developer.android.com/reference/android/app/Activity.html#onCreate(android.os.Bundle)" rel="external nofollow noreferrer">onCreate()</a></code>&nbsp;and&nbsp;<code><a href="https://developer.android.com/reference/android/app/Activity.html#onResume()" rel="external nofollow noreferrer">onResume()</a></code>. Potentially long running operations such as network or database operations, or computationally expensive calculations such as resizing bitmaps should be done in a worker thread (or in the case of databases operations, via an asynchronous request).</p>
<p>The most effective way to create a worker thread for longer operations is with the&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html" rel="external nofollow noreferrer">AsyncTask</a></code>&nbsp;class. Simply extend&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html" rel="external nofollow noreferrer">AsyncTask</a></code>&nbsp;and implement the<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html#doInBackground(Params...)" rel="external nofollow noreferrer">doInBackground()</a></code>&nbsp;method to perform the work. To post progress changes to the user, you can call&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html#publishProgress(Progress...)" rel="external nofollow noreferrer">publishProgress()</a></code>, which invokes the<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html#onProgressUpdate(Progress...)" rel="external nofollow noreferrer">onProgressUpdate()</a></code>&nbsp;callback method. From your implementation of&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html#onProgressUpdate(Progress...)" rel="external nofollow noreferrer">onProgressUpdate()</a></code>&nbsp;(which runs on the UI thread), you can notify the user. For example:</p>
<pre class="prettyprint linenums">private class DownloadFilesTask extends AsyncTask&lt;URL, Integer, Long&gt; {<br />&nbsp; &nbsp; // Do the long-running work in here<br />&nbsp; &nbsp; protected Long doInBackground(URL... urls) {<br />&nbsp; &nbsp; &nbsp; &nbsp; int count = urls.length;<br />&nbsp; &nbsp; &nbsp; &nbsp; long totalSize = 0;<br />&nbsp; &nbsp; &nbsp; &nbsp; for (int i = 0; i &lt; count; i++) {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; totalSize += Downloader.downloadFile(urls[i]);<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; publishProgress((int) ((i / (float) count) * 100));<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; // Escape early if cancel() is called<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if (isCancelled()) break;<br />&nbsp; &nbsp; &nbsp; &nbsp; }<br />&nbsp; &nbsp; &nbsp; &nbsp; return totalSize;<br />&nbsp; &nbsp; }

&nbsp; &nbsp; // This is called each time you call publishProgress()<br />&nbsp; &nbsp; protected void onProgressUpdate(Integer... progress) {<br />&nbsp; &nbsp; &nbsp; &nbsp; setProgressPercent(progress[0]);<br />&nbsp; &nbsp; }

&nbsp; &nbsp; // This is called when doInBackground() is finished<br />&nbsp; &nbsp; protected void onPostExecute(Long result) {<br />&nbsp; &nbsp; &nbsp; &nbsp; showNotification("Downloaded " + result + " bytes");<br />&nbsp; &nbsp; }<br />}</pre>
<p>To execute this worker thread, simply create an instance and call&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html#execute(Params...)" rel="external nofollow noreferrer">execute()</a></code>:</p>
<pre class="prettyprint linenums">new DownloadFilesTask().execute(url1, url2, url3);</pre>
<p>Although it's more complicated than&nbsp;<code><a href="https://developer.android.com/reference/android/os/AsyncTask.html" rel="external nofollow noreferrer">AsyncTask</a></code>, you might want to instead create your own&nbsp;<code><a href="https://developer.android.com/reference/java/lang/Thread.html" rel="external nofollow noreferrer">Thread</a></code>&nbsp;or&nbsp;<code><a href="https://developer.android.com/reference/android/os/HandlerThread.html" rel="external nofollow noreferrer">HandlerThread</a></code>&nbsp;class. If you do, you should set the thread priority to "background" priority by calling&nbsp;<code><a href="https://developer.android.com/reference/android/os/Process.html#setThreadPriority(int)" rel="external nofollow noreferrer">Process.setThreadPriority()</a></code>&nbsp;and passing&nbsp;<code><a href="https://developer.android.com/reference/android/os/Process.html#THREAD_PRIORITY_BACKGROUND" rel="external nofollow noreferrer">THREAD_PRIORITY_BACKGROUND</a></code>. If you don't set the thread to a lower priority this way, then the thread could still slow down your app because it operates at the same priority as the UI thread by default.</p>
<p>If you implement&nbsp;<code><a href="https://developer.android.com/reference/java/lang/Thread.html" rel="external nofollow noreferrer">Thread</a></code>&nbsp;or&nbsp;<code><a href="https://developer.android.com/reference/android/os/HandlerThread.html" rel="external nofollow noreferrer">HandlerThread</a></code>, be sure that your UI thread does not block while waiting for the worker thread to complete&mdash;do not call<code><a href="https://developer.android.com/reference/java/lang/Object.html#wait()" rel="external nofollow noreferrer">Thread.wait()</a></code>&nbsp;or&nbsp;<code><a href="https://developer.android.com/reference/java/lang/Thread.html#sleep(long)" rel="external nofollow noreferrer">Thread.sleep()</a></code>. Instead of blocking while waiting for a worker thread to complete, your main thread should provide a&nbsp;<code><a href="https://developer.android.com/reference/android/os/Handler.html" rel="external nofollow noreferrer">Handler</a></code>&nbsp;for the other threads to post back to upon completion. Designing your application in this way will allow your app's UI thread to remain responsive to input and thus avoid ANR dialogs caused by the 5 second input event timeout.</p>
<p>The specific constraint on&nbsp;<code><a href="https://developer.android.com/reference/android/content/BroadcastReceiver.html" rel="external nofollow noreferrer">BroadcastReceiver</a></code>&nbsp;execution time emphasizes what broadcast receivers are meant to do: small, discrete amounts of work in the background such as saving a setting or registering a&nbsp;<code><a href="https://developer.android.com/reference/android/app/Notification.html" rel="external nofollow noreferrer">Notification</a></code>. So as with other methods called in the UI thread, applications should avoid potentially long-running operations or calculations in a broadcast receiver. But instead of doing intensive tasks via worker threads, your application should start an&nbsp;<code><a href="https://developer.android.com/reference/android/app/IntentService.html" rel="external nofollow noreferrer">IntentService</a></code>&nbsp;if a potentially long running action needs to be taken in response to an intent broadcast.</p>
<p>Another common issue with&nbsp;<code><a href="https://developer.android.com/reference/android/content/BroadcastReceiver.html" rel="external nofollow noreferrer">BroadcastReceiver</a></code>&nbsp;objects occurs when they execute too frequently. Frequent background execution can reduce the amount of memory available to other apps. For more information about how to enable and disable&nbsp;<code><a href="https://developer.android.com/reference/android/content/BroadcastReceiver.html" rel="external nofollow noreferrer">BroadcastReceiver</a></code>&nbsp;objects efficiently, see<a href="https://developer.android.com/training/monitoring-device-state/manifest-receivers.html" rel="external nofollow noreferrer">Manipulating Broadcast Receivers on Demand</a>.</p>
<p><strong>Tip:</strong>&nbsp;You can use&nbsp;<code><a href="https://developer.android.com/reference/android/os/StrictMode.html" rel="external nofollow noreferrer">StrictMode</a></code>&nbsp;to help find potentially long running operations such as network or database operations that you might accidentally be doing on your main thread.</p>
<h2>Reinforce Responsiveness</h2>
<hr />
<p>Generally, 100 to 200ms is the threshold beyond which users will perceive slowness in an application. As such, here are some additional tips beyond what you should do to avoid ANR and make your application seem responsive to users:</p>
<ul><li>If your application is doing work in the background in response to user input, show that progress is being made (such as with a&nbsp;<code><a href="https://developer.android.com/reference/android/widget/ProgressBar.html" rel="external nofollow noreferrer">ProgressBar</a></code>&nbsp;in your UI).</li>
<li>For games specifically, do calculations for moves in a worker thread.</li>
<li>If your application has a time-consuming initial setup phase, consider showing a splash screen or rendering the main view as quickly as possible, indicate that loading is in progress and fill the information asynchronously. In either case, you should indicate somehow that progress is being made, lest the user perceive that the application is frozen.</li>
<li>Use performance tools such as&nbsp;<a href="https://developer.android.com/tools/help/systrace.html" rel="external nofollow noreferrer">Systrace</a>&nbsp;and&nbsp;<a href="https://developer.android.com/tools/help/traceview.html" rel="external nofollow noreferrer">Traceview</a>&nbsp;to determine bottlenecks in your app's responsiveness.</li></ul>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqde7lx9.html">UV动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1dv44q.html">jQuery 更改checkbox的状态，无效</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z2n7d8.html">Unity3d 鼠标拣选小功能集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e0p79.html">ggts下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mkx6kq.html">LeetCode 191&period; Number of 1 Bits  Question</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgg7mr8.html">Python 保存爬行动物捕捉网页</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3vzy8.html">Sass入门：第二章</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zojlo1q.html">Mybatis的&commat;Options注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kn2049.html">Http请求封装基类HttpHelper&period;cs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25x219.html">【转】Linux的nm查看动态库和静态库的符号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvg2ek8.html">flask-session 在redis中存储session</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzjrvq.html">django&plus;celery &plus;rabbitmq</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256xgvq.html">Java Generator</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1roo148.html">MySQL5&period;7在JSON解析后丢失小数部分的Bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rxmn68.html">Stanford Corenlp学习笔记&mdash;&mdash;词性标注</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy75y19.html">&lbrack;LeetCode&rsqb; 830&period; Positions of Large Groups&lowbar;Easy tag&colon; Two Pointers</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvw74xq.html">ini&lowbar;set的用法介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjjjj08.html">7&period; 集成学习（Ensemble Learning）Stacking</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko5xy5q.html">&period;Net和SqlServer的事务处理实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjk0m28.html">数据输入&mdash;&mdash;生成你需要的echart图&lpar;堆积柱状图、扇形图、嵌套环形图&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqvo7v18.html">WebStorm设置左侧菜单栏背景色和样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7w3g19.html">HTTP协议详解篇（待续）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxrx60q.html">2016全国研究生数学建模A题多无人机协同任务规划&mdash;&mdash;基于分布式协同多旅行商MTSP遗传算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1n2749.html">9&period;5---所有字符串的排列组合（CC150）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g0kneq.html">js 函数前的&plus;号</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mvvn08.html">mysql 数据库字符集的指定</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnkkdjq.html">ndk学习16&colon; unix domain socket</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z2p6n8.html">ganglia及ganglia-api相关介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7wv4e9.html">&lbrack;k&rsqb;web页面-browser兼容问题-1</a>
			</li>
						<li><a href="https://www.batexi.com/a/495vkxzq.html">python装饰器初探</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
